'use strict';

module.exports = inspectorLog;

// black hole
var nullStream = new (require('stream').Writable)();
nullStream._write = function () {};

/**
 * Outputs a `console.log()` to the Node.js Inspector console *only*.
 */
function inspectorLog() {
  var stdout = console._stdout;
  console._stdout = nullStream;
  console.log.apply(console, arguments);
  console._stdout = stdout;
}
//# sourceMappingURL=inspector-log.js.map